#include <qapplication.h>
#include <qdom.h>
#include <qfile.h>

#include "tom.h"
#include "tomitem.h"
#include "tomtaskgroup.h"
#include "tomtaskaction.h"

Tom parseXMLwithDOM( QDomDocument &d );

int main()
{

    QFile f( "./tom.xml" );
    QDomDocument d;
    QString errorMsg;
    int errorLine, errorColumn;
    //QString locale( "en" );
    Tom tom;

    d.setContent( &f, &errorMsg, &errorLine, &errorColumn );

    tom = parseXMLwithDOM(d);
} 


Tom parseXMLwithDOM( QDomDocument &d ){

    Tom m_tom;

    QDomElement tom = d.namedItem("tom").toElement();

    QDomNode tg = tom.firstChild();
    for ( ; !tg.isNull(); tg = tg.nextSibling() ) {
    	if ( tg.isElement() && tg.toElement().tagName() == "task_group" ) {

		TomTaskGroup* tomTaskGroup = new TomTaskGroup();
    		QDomElement tg_e = tg.toElement();
		QDomElement task_group_name = tg_e.namedItem("name").toElement();
    		qDebug ( "Task_group name: " + task_group_name.text() + "\n");
		tomTaskGroup->setName(task_group_name.text());

		QDomNode task_ac = tg_e.firstChild();
    		for ( ; !task_ac.isNull(); task_ac = task_ac.nextSibling() ) {
    			if ( task_ac.isElement() && task_ac.toElement().tagName() == "task_action" ) {

				TomTaskAction* tomTaskAction = new TomTaskAction();
    				QDomElement task_ac_e = task_ac.toElement();
				QDomElement task_ac_name = task_ac_e.namedItem("name").toElement();
    				qDebug ( "Task_action name: " + task_ac_name.text() + "\n");
				tomTaskAction->setName(task_ac_name.text());

				QDomNode item = task_ac_e.firstChild();
    				for ( ; !item.isNull(); item = item.nextSibling() ) {
    					if ( item.isElement() && item.toElement().tagName() == "item" ) {

						TomItem* tomItem = new TomItem();
    						QDomElement item_e = item.toElement();

						QDomElement item_prog = item_e.namedItem("program").toElement();
    						qDebug ( "Item Program: " + item_prog.text() + "\n");
						tomItem->setProgram(item_prog.text());

						QDomElement item_name = item_e.namedItem("name").toElement();
    						qDebug ( "Item Name: " + item_name.text() + "\n");
						tomItem->setName(item_name.text());

						QDomElement item_desc = item_e.namedItem("desc").toElement();
    						qDebug ( "Item Desc: " + item_desc.text() + "\n");
						tomItem->setDesc(item_desc.text());

						tomTaskAction->tomItems.append(tomItem);
					}
    				}

				tomTaskGroup->tomTaskActions.append(tomTaskAction);
			}
    		}
		m_tom.tomTaskGroups.append(tomTaskGroup);
	}
    }

    return m_tom;
}
